#include "../defs.h"
#include "../errors.h"
#include "../Lock/lock.h"
#include "../mountrec.h"
#include "../Volume/volinfo.h"
#include "../Volume/volbmap.h"
#include "../btree/btree.h"
#include "../DevSupport/readwrite.h"
#include <stdlib.h>

#define HACK

#ifdef USER
int macmount(char *devname, int partitionnumber, MOUNT_RECORD *mr)
{
  int rc;
  
  mr->viblock=make_lock();
  mr->vbmaplock=make_lock();

  if ((rc=initreadwrite(devname,partitionnumber,mr))) {
    unmake_lock(mr->viblock);
    unmake_lock(mr->vbmaplock);
    return rc;
  }

#ifdef HACK
  if (mr->sr.sectsize!=BYTESPERSECT) {
    closereadwrite(mr);
    unmake_lock(mr->viblock);
    unmake_lock(mr->vbmaplock);
    return -1;
  }
#endif


  
  if ((rc=readvolinfo(mr)))
    return rc;
  
  if ((rc=readvolbmap(mr)))
    return rc;
  
  if ((rc=BTreeMount(mr)))
    return rc;
  
  return 0;
}
#endif

#ifdef VFS
struct vnode;

int macmount(struct vnode *device, int partitionnumber, MOUNT_RECORD *mr)
{
  int rc;

  mr->viblock=make_lock();
  mr->vbmaplock=make_lock();

  if ((rc=initreadwrite(device,partitionnumber,mr))) {
    unmake_lock(mr->viblock);
    unmake_lock(mr->vbmaplock);
    return rc;
  }

#ifdef HACK
  if (mr->sr.sectsize!=BYTESPERSECT) {
    closereadwrite(mr);
    unmake_lock(mr->viblock);
    unmake_lock(mr->vbmaplock);
    return -1;
  }
#endif


  if ((rc=readvolinfo(mr)))
    return rc;
  
  if ((rc=readvolbmap(mr)))
    return rc;
  
  if ((rc=BTreeMount(mr)))
    return rc;
  
  return 0;
}
#endif


int syncmountrecord(MOUNT_RECORD *mr)
{
  int rc;


  if ((rc=BTreeSync(mr)))
    return rc;

  if ((rc=writevolbmap(mr)))
    return rc;
  
  if ((rc=writevolinfo(mr)))
    return rc;

  return 0;
}


int macunmount(MOUNT_RECORD *mr)
{
  int rc;
  
  if ((rc=BTreeUnmount(mr)))
    return rc;

  if ((rc=writevolbmap(mr)))
    return rc;

  free(mr->vbmap);
  
  if ((rc=writevolinfo(mr)))
    return rc;
  
  if ((rc=closereadwrite(mr)))
    return rc;

  unmake_lock(mr->viblock);
  unmake_lock(mr->vbmaplock);

  
  return 0;

}












