#include <stdio.h>
#include "../Includes/macfs_user.h"
#include <ctype.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <sys/file.h>
#include <stdlib.h>
#include <sysent.h>
#include <time.h>

struct timeval tv;

void start_timing()
{
    gettimeofday(&tv, NULL);
}

double end_timing()
{
    struct timeval tv2;
    gettimeofday(&tv2, NULL);
    return(tv2.tv_sec - tv.tv_sec
	   + 1.e-6 * (tv2.tv_usec - tv.tv_usec));
}


#define NOCORRECTNESS

/*#define BLOCKSIZ 4*1536 */
#define FILESIZE 500000

MOUNT_RECORD mr;

char *fn=":tmp:testfile";

int blocksiz;

int main(int argc, char *argv[])
{
  MFILE mfile;
  BYTE *buf;

  LONGWORD bytesread, byteswritten, actualbs;
  char *devname, *partnum;
  int i, rc;
  double time;

  if (argc!=2) {
    printf("usage: mac_append_test <blocksize>\n");
    exit(1);
  } else {
    blocksiz=atoi(argv[1]);
    printf("blocksiz=%d\n",blocksiz);
  }

  devname=getenv("MACDEVICE");
  partnum=getenv("MACPART");



  if (devname==NULL || partnum==NULL) {
    puts("Please set the environment variables MACDEVICE and MACPART before");
    puts("running any mac utility.  MACDEVICE is like /dev/rz4h or /dev/fd0");
    exit(1);
  }


  if ((buf=(BYTE *)malloc(blocksiz))==NULL) {
    puts("out of memory");
    exit(2);
  }

  for (i=0;i<blocksiz; i++) 
    buf[i]='Z';



  rc=macmount(devname, atoi(partnum), &mr);

  
  
  if (rc) {
    puts("macmount failed");
    exit(2);
  }
  
  initopencatrectable();
  
  
  if ((rc=maccreatefile(&mr, fn, 3, &mfile))) {
    printf("maccreate failed rc=%d\n",rc);
    macunmount(&mr);
    exit(1);
  }
  
  start_timing();

  for (i=0;i<FILESIZE;i+=blocksiz) {

    if ((rc=macwrite(&mfile,(LONGWORD)blocksiz,buf,&byteswritten))) {
      printf("macwrite(start=%d) failed rc=%d\n",i,rc);
      macunmount(&mr);
      exit(2);
    }
    if (byteswritten!=blocksiz) {
      printf("wrote %d bytes but expected %d!\n",byteswritten,blocksiz);
      exit(2);
    }
  }

  time=end_timing();

  printf("wrote %d bytes in %d size chunks in %f seconds - %f bytes/sec\n",i,
	 blocksiz, time, ((double) i)/time );

  if ((rc=macclose(&mfile))) {
    macunmount(&mr);
    printf("macclose failed with rc=%d\n",rc);
    exit(3);
  }

  puts("done.");


  if ((rc=macunmount(&mr))) {
    printf("macunmount failed with rc=%d\n", rc);
    exit(4);
  }

  
  exit(0);
  
}




