#include <stdio.h>
#include "../Includes/macfs_user.h"
#include <ctype.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <stdlib.h>
#include <sysent.h>

MOUNT_RECORD mr;

int main(int argc, char *argv[])
{
  int rc;

  puts("Hi!");

  if (argc!=3) {
    puts("usage: mac <device-or-file> <partition number>");
    exit(0);
  }

  if (macmount(argv[1],atoi(argv[2]),&mr)) {
    printf("Sorry, couldn't mount %s\n", argv[1]);
    exit(1);
  }

  initopencatrectable();

  menu(&mr);

  if ((rc=macunmount(&mr))) {
    printf("macunmount returned with error code %d\n", rc);
  }

  exit(0); 

}





int menu(MOUNT_RECORD *mr)
{
  SECTNUMTYPE sect;
  char        *buf, *tmp;
  char        pn[200];
  char        inp[256];
  char        nn[200];
  int         numsects;
  int         sectsprocessed;
  int rc;
  unsigned long start, length, bytesread;
  CATRECANDNAME *crs;
  int i;
  int mode;
  MFILE file;

  sect=0;

  if ((buf=(char *)malloc(BYTESPERSECT*MAXSECTSPEROP))==NULL)
    return -1;

  puts("Menu");
  puts("====");
  puts("S)Show Volume Info");
  puts("V)Read Volume Info");
  puts("K)Write Volume Info");
  puts("R)Read Sectors and Display");
  puts("W)Write Sectors");
  puts("O)pen File");
  puts("F)Read File");
  puts("D)irectory");
  puts("C)heck Filesystem");
  puts("M)ake a File");
  puts("Y)Make a Folder");
  puts("L)Delete a File");
  puts("B)Delete a Folder");
  puts("+)Move a File or Folder");
  puts("H)Write File");
  puts("!)Close File");
  puts("Q)uit");
  puts("");

  while (1) {

    printf("SVKRWOFDCMYLB+H!Q? ");
    fflush(stdin);fflush(stdout);fflush(stdin);fflush(stdout);
    gets(inp);
    switch (toupper(*inp)) {
    case 'S':
      showvolinfo(&(mr->vib));
      break;
    case 'V': 
      puts("Reading Volume Information...\n");
      if (readvolinfo(mr))
	puts("FAILED");
      break;
    case 'K':
      if (writevolinfo(mr))
	puts("FAILED");
      break;
    case 'R':
      do {
	fflush(stdin);fflush(stdout);
	printf("<ss ns>=> ");
	scanf("%d %d", &sect, &numsects);
	if (numsects>MAXSECTSPEROP) 
	  printf("%d Sectors Per Operation is Maximum\n", MAXSECTSPEROP);
      } while (numsects>MAXSECTSPEROP);
      printf("Reading Sectors %d through %d...\n", sect, sect+numsects-1);
      if ((sectsprocessed=readsects(mr,sect,numsects,buf))<=0) {
	printf("FAILED TO READ ANY SECTORS\n");
        break;
      }
      if (sectsprocessed!=numsects)
	printf("Only read %d sectors starting at %d\n",sectsprocessed, sect);
      printf("Print Sectors?");
      if (toupper(getcharnobuf())=='Y') 
	for (tmp=buf;tmp<(buf+sectsprocessed*BYTESPERSECT);tmp+=BYTESPERSECT) {      	  printf("Sector %d:\n", (tmp-buf)/BYTESPERSECT+sect);
	   showsect(tmp); 
	}
      break;
    case 'W':
      puts("UNIMPLEMENTED");
      break;
    case 'O':
      printf("Pathname (:mydir:myfile)?");
      fflush(stdin);fflush(stdout);
      gets(pn);
      printf("Mode (1=r, 2=w, 4=append, 8=shared):");
      scanf("%d",&mode);
      printf("Looking for file/dir '%s'\n", pn);
      if ((rc=macopen(mr,pn,mode,&file))) {
	printf("macopen failed with rc=%d\n", rc);
	break;
      }
      printf("macopen was successful... First extent is %d(%d)\n",
	     file.cr->U.cdrFilRec.filExtRec[0].first,
	     file.cr->U.cdrFilRec.filExtRec[0].length);
      break;
      
    case 'F':
      printf("<s l>?");
      scanf("%lu %lu", &start, &length);
      if ((rc=macseek(&file,(SIGNEDLONGWORD)start,SEEKFROMBEGINING))) {
	printf("macseek returned error code %d\n", rc);
	break;
      }
      if ((rc=macread(&file,length,buf,&bytesread))<0) {
	printf("macread returned error code %d\n", rc);
	break;
      }
      printf("macread read %lu bytes\n",bytesread);
      printf("Print as String(y/n)?");
      
      if (toupper(getcharnobuf())=='Y') {
/*
	for (tmp=buf;tmp<(buf+bytesread+BYTESPERSECT);tmp+=BYTESPERSECT) {
	  puts("");
	  showsect(tmp); 
	}
*/

	for (i=0;i<bytesread;i++) {
	  if (buf[i]==13)
	    putchar('\n');
	  else 
	    putchar(buf[i]);
	}

      }
      puts("");

      break;

    case 'D':
      printf("Directory ID?");
      fflush(stdin);fflush(stdout);
      scanf("%d",&start);
      printf("working...\n");
      rc=macdirentries(mr, start, &crs);
      if (rc<0) {
	printf("macdirentries returned error code %d\n", rc);
	break;
      }
      printf("type    PhysSiz     LogSiz     ID  Created Modified Name\n"
             "=============================================================================\n");
      for (i=0;i<rc;i++) {
	switch (crs[i].cr.cdrType) {
	case CDR_DIR: printf("FOLD "); break;
	case CDR_FILE: printf("FILE "); break;
	case CDR_DTHREAD: printf("DTHD "); break;
	case CDR_FTHREAD: printf("FTHD "); break;
	default: printf("???? ");
	}
	switch(crs[i].cr.cdrType) {
	case CDR_FILE: printf("%10lu ", crs[i].cr.U.cdrFilRec.filPyLen); break;
	default: printf("           "); 
	}
	switch(crs[i].cr.cdrType) {
	case CDR_FILE: printf("%10lu ", crs[i].cr.U.cdrFilRec.filLgLen); break;
	default: printf("           ");
	}
	switch (crs[i].cr.cdrType) {
	case CDR_DIR: printf(" %5d", crs[i].cr.U.cdrDirRec.dirDirID); break;
	case CDR_FILE: printf(" %5d", crs[i].cr.U.cdrFilRec.filFlNum); break;
	case CDR_DTHREAD: printf(" NO ID"); break;
	case CDR_FTHREAD: printf(" NO ID"); break;
	default: printf("???? ");
	}
	switch (crs[i].cr.cdrType) {
	case CDR_DIR: printf(" %8X", crs[i].cr.U.cdrDirRec.dirCrDat); break;
	case CDR_FILE: printf(" %8X", crs[i].cr.U.cdrFilRec.filCrDat); break;
	case CDR_DTHREAD: printf(" NO DATE "); break;
	case CDR_FTHREAD: printf(" NO DATE "); break;
	default: printf("???? ");
	}
	switch (crs[i].cr.cdrType) {
	case CDR_DIR: printf(" %8X", crs[i].cr.U.cdrDirRec.dirMdDat); break;
	case CDR_FILE: printf(" %8X", crs[i].cr.U.cdrFilRec.filMdDat); break;
	case CDR_DTHREAD: printf(" NO DATE "); break;
	case CDR_FTHREAD: printf(" NO DATE "); break;
	default: printf("???? ");
	}
	printf(" %-25s",crs[i].name);
	puts("");
      }
      free(crs);
      break;

    case 'C':
      rc=checkvbmap(mr);
      if (rc) {
	printf("checkvbmap returned %d\n", rc);
      } else {
	puts("Volume Bit Map is a happy camper.");
      }
      rc=CheckFsBtree(mr,&(mr->catalog),1);
      if (rc) {
	printf("CheckFsBtree(catalog) returned %d\n", rc);
      } else {
	puts("Catalog BTree is a happy camper.");
      }
      rc=CheckFsBtree(mr,&(mr->extents),0);
      if (rc) {
	printf("CheckFsBtree(extents) returned %d\n", rc);
      } else {
	puts("Extents Btree is a happy camper.");
      }
      break;

    case 'M':
      printf("absolute pathname of file?");
      gets(pn);
      printf("mode to open?");
      scanf("%d",&mode);
      rc=maccreatefile(mr, pn, mode, &file);
      if (rc) {
	printf("maccreatefile failed with rc=%d\n", rc );
      } else {
	printf("Success: New file id is %d\n", file.cr->U.cdrFilRec.filFlNum);
      }
      break;

    case 'Y':
      printf("absolute pathname of folder?");
      gets(pn);
      rc=maccreatefolder(mr, pn);
      if (rc) {
	printf("maccreatefolder returned %d\n", rc);
      } else {
	printf("Success!");
      }
      break;

    case 'L':
      printf("absolute pathname of file?");
      gets(pn);
      rc=macdeletefile(mr,pn);
      if (rc) {
	printf("macdeletefile returned %d\n", rc);
      } else {
	puts("Success.");
      }
      break;

    case 'B':
      printf("absolute pathname of folder?");
      gets(pn);
      rc=macdeletefolder(mr,pn);
      if (rc) {
	printf("macdeletefolder returned %d\n", rc);
      } else {
	puts("Success.");
      }
      break;
      
    case '+':
      printf("absolute pathname of item?");
      gets(pn);
      printf("new pathname for item?");
      gets(nn);
      rc=macmove(mr, pn, nn);
      if (rc) {
	printf("macrenamefile returned %d\n", rc);
      } else {
	puts("Success.");
      }
      break;

    case 'H':
      printf("String for buf...?");
      fflush(stdin);fflush(stdout);
      gets(pn);
      printf("<s l>?");
      scanf("%d %d", &start, &length);
      for(i=0;i<length;i++)
	buf[i]=pn[i%strlen(pn)];
      if ((rc=macseek(&file,start,SEEKFROMBEGINING))) {
	printf("macseek returned %d\n", rc);
	break;
      }
      rc=macwrite(&file,length,buf,&bytesread);
      if (rc) {
	printf("macwrite returned %d\n", rc);
      } else {
	printf("macwrite wrote %lu bytes\n", bytesread);
      }
      break;

    case '!':
      rc=macclose(&file);
      if (rc) 
	printf("macclose returned rc=%d\n", rc);
      else
	printf("macclose successful\n");
      break;

    case 'Q':
    case EOF: 
      free(buf);
      return 0;
      break;
    default:
      break;
    }
  }
}

int getcharnobuf()
{
  char c;

  fflush(stdin);fflush(stdout); fflush(stdout);
  c=(read(0,&c,1) == 1) ? (unsigned char) c : EOF;
  fflush(stdin);fflush(stdout); fflush(stdout);
  return c;

}


int textdump(unsigned char buf[], unsigned long length)
{
  int i;

  for (i=0;i<length;i++) {
    if (isalnum(buf[i])) 
      putchar(buf[i]);
    else
      putchar('.');
  }
  return 0;
}

int showsect(unsigned char buf[])
{
  int i, j;
  

  for (i=0; i<BYTESPERSECT; i++) {
    if (!(i%16)) {
      if (i!=0) {
	 printf("  ");
	 for (j=i-16;j<i;j++)
	   putchar(isalnum(buf[j])? buf[j]: '.');
       }
      printf("\n%5X: %2x", i, buf[i]);
      continue;
    }
    if (!(i%8)&(i!=0)) {
      printf(" - %2x", buf[i]);
    } else {
      printf(" %2x", buf[i]);
    }
  }
  
  printf("  ");
  for(j=i-16;j<i;j++)
    putchar(isalnum(buf[j])? buf[j]: '.');
    

  printf("\n\n");

  return 0;
}


int showvolinfo(struct volinfo *vi)
{
  printf(
      "\tSigWord   0x%X\n"
      "\tCrDate    0x%X\n"
      "\tLsMod     0x%X\n"
      "\tAtrb      0x%X\n"
      "\tNmFls     0x%X\n"
      "\tVBMSt     0x%X\n"
      "\tAllocPtr  0x%X\n"
      "\tNmAlBlks  0x%X\n"
      "\tAlBlkSiz  0x%X\n"
      "\tClpSiz    0x%X\n"
      "\tAlBlSt    0x%X\n"
      "\tNxtCNID   0x%X\n"
      "\tFreeBks   0x%X\n"
      "\tVNlen     0x%X\n"
      "\tVN        '%s'\n"
      "\tVolBkUp   0x%X\n"
      "\tVSeqNum   0x%X\n"
      "\tWrCnt     0x%X\n"
      "\tXTClpSiz  0x%X\n"
      "\tCTClpSiz  0x%X\n"
      "\tNmRtDirs  0x%X\n"
      "\tFilCnt    0x%X\n"
      "\tDirCnt    0x%X\n"
      "\tFndrInfo  <not yet>\n"
      "\tVCSize    0x%X\n"
      "\tVCBMSize  0x%X\n"
      "\tCtlCSize  0x%X\n"
      "\tXTFlSize  0x%X\n"
      "\tXTExtRec  %d(%d) %d(%d) %d(%d)\n"
      "\tCTFlSize  0x%X\n"
      "\tCTExtRec  %d(%d) %d(%d) %d(%d)\n",
	   vi->SigWord,     
           vi->CrDate,      
           vi->LsMod,       
           vi->Atrb,        
           vi->NmFls,       
           vi->VBMSt,       
           vi->AllocPtr,    
           vi->NmAlBlks,    
           vi->AlBlkSiz,    
           vi->ClpSiz,      
           vi->AlBlSt,      
           vi->NxtCNID,     
           vi->FreeBks,     
           vi->VNlen,       
           vi->VN,      
           vi->VolBkUp,     
           vi->VSeqNum,     
           vi->WrCnt,       
           vi->XTClpSiz,    
           vi->CTClpSiz,    
           vi->NmRtDirs,    
           vi->FilCnt,      
           vi->DirCnt,      
        /*   vi->FndrInfo[32], */
           vi->VCSize,      
           vi->VCBMSize,    
           vi->CtlCSize,    
           vi->XTFlSize,    
      vi->XTExtRec[0].first,
      vi->XTExtRec[0].length,
      vi->XTExtRec[1].first,
      vi->XTExtRec[1].length,
      vi->XTExtRec[2].first,
      vi->XTExtRec[2].length,

      vi->CTFlSize,   

      vi->CTExtRec[0].first,
      vi->CTExtRec[0].length,
      vi->CTExtRec[1].first,
      vi->CTExtRec[1].length,
      vi->CTExtRec[2].first,
      vi->CTExtRec[2].length

         );

  return 0;
}


