#include <stdio.h>
#include <stdlib.h>
#include <sysent.h>
#include <ctype.h>
#include "../Includes/macfs_user.h"

void main()
{
  MOUNT_RECORD mr;
  int rc;
  char *devname, *partnum;
  int fail;

  devname=getenv("MACDEVICE");
  partnum=getenv("MACPART");

  printf("Mounting '%s' - partition %d: ", devname, atoi(partnum));

  rc=macmount(devname, atoi(partnum), &mr);

  if (rc) {
    printf("FAILED (%d)\n", rc);
    exit(1);
  } else 
    puts("SUCCESSFUL");

  fail=0;

  printf("Checking Volume Bitmap : ");

  if ((rc=checkvbmap(&mr))) {
    printf("FAILED (%d)\n", rc);
    fail=1;
  } else
    puts("SUCCESSFUL");

  printf("Checking Catalog B-Tree: ");
  
  if ((rc=CheckFsBtree(&mr, &(mr.catalog), 1))) {
    printf("FAILED (%d)\n", rc);
    fail=1;
  } else
    puts("SUCCESSFUL");

  printf("Checking Extents B-Tree: ");
  
  if ((rc=CheckFsBtree(&mr, &(mr.extents), 0))) {
    printf("FAILED (%d)\n", rc);
    fail=1;
  } else
    puts("SUCCESSFUL");

  exit(-fail);

}
